#|
This file is part of Ordo.

Copyright (C) 2025 Ray Miller

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation, version 3.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see <https://www.gnu.org/licenses/>.
|#

(define-module (ordo handler)
  #:use-module (srfi srfi-9)
  #:use-module (ordo logger)
  #:export (make-handler
            handler?
            handler-name
            handler-action
            handler
            run-handler))

(define-record-type <handler>
  (make-handler name action)
  handler?
  (name handler-name)
  (action handler-action))

(define* (handler #:key name action)
  (make-handler name action))

(define (run-handler h conn)
  (log-msg 'NOTICE "Running handler: " (handler-name h))
  ((handler-action h) conn))
